 /**********************************************************************************
 * Modified: InnovativeElectronics.com -- EMS Ethernet Module & DT-ARM NUC120 Board *
 ***********************************************************************************/
#include <stdio.h>
#include "NUC1xx.h"
#include "DrvSYS.h"
#include "DrvSPI.h"
#include "DrvGPIO.h"
#include "hw_config.h"

    /*************************************************************************************
    ** Function name: RCC_Configuration
    *************************************************************************************/
    void RCC_Configuration(void)
    {
    	UNLOCKREG();
    	DrvSYS_SetOscCtrl(E_SYS_XTL12M, 1); // Enable the 12MHz oscillator oscillation
    	DrvSYS_SelectHCLKSource(0); // HCLK clock source. 0: external 12MHz; 4:internal 22MHz RC oscillator
    	LOCKREG();
    	DrvSYS_SetClockDivider(E_SYS_HCLK_DIV, 0); /* HCLK clock frequency = HCLK clock source / (HCLK_N + 1) */


    }
    /*************************************************************************************
    ** Function name: GPIO_Configuration
    *************************************************************************************/
    void GPIO_Configuration(void)
    {
    	DrvGPIO_Open( E_GPC, 15, E_IO_OUTPUT ); // RESET
    }

    /*************************************************************************************
    ** Function name: SPI_Configuration
    *************************************************************************************/
    void SPI_Configuration(void)
    {

		//uint32_t tmp;
		DrvGPIO_InitFunction(E_FUNC_SPI1);
		//DrvGPIO_InitFunction(E_FUNC_SPI1_2BIT_MODE);
		DrvSPI_Open(eDRVSPI_PORT1, eDRVSPI_MASTER, eDRVSPI_TYPE1, 8);
		DrvSPI_SetEndian(eDRVSPI_PORT1, eDRVSPI_MSB_FIRST); //??SPI1???????:????/??MSB
		DrvSPI_DisableAutoSS(eDRVSPI_PORT1); //????????
		DrvSPI_SetSlaveSelectActiveLevel(eDRVSPI_PORT1, eDRVSPI_ACTIVE_HIGH_RISING); //???????????:????????
		DrvSPI_Set2BitTransferMode(eDRVSPI_PORT1, TRUE); //??2??????I/O ??
		DrvSPI_SetClockFreq(eDRVSPI_PORT1, 1000000, 0); //??SPI??????8MHz
		uint32_t x = DrvSPI_GetClock1Freq(eDRVSPI_PORT1);

    }

    /*************************************************************************************
    ** Function name: delay_ms
    ** Descriptions: 1ms(???12MHZ)?????
    ** input parameters: count
    ** output parameters: ?
    ** Returned value: ?
    *************************************************************************************/
    void delay_ms(uint32_t count)
    {
		uint32_t i,j;
		for(i=count;i>0;i--)
		for(j=2395;j>0;j--);
    }

    /*************************************************************************************
    ** Function name: SPInet_ReadWrite
    ** Descriptions: SPI??????
    ** input parameters: ????
    ** output parameters: ?
    ** Returned value: ????
    *************************************************************************************/
    uint8_t SPInet_ReadWrite(uint8_t writedat)
    {
		uint32_t au32SourceData;
		uint32_t au32DestinationData;

		// configure transaction length as 8 bits
		DrvSPI_SetBitLength(eDRVSPI_PORT1, 8);

		au32SourceData = writedat;
		DrvSPI_SingleWrite(eDRVSPI_PORT1, &au32SourceData);
		while (DrvSPI_IsBusy(eDRVSPI_PORT1)) {} //??SPI????

		DrvSPI_DumpRxRegister(eDRVSPI_PORT1, &au32DestinationData, 1);

    return (au32DestinationData);
    }

        /*************************************************************************************
        ** Function name: Set_System
        ** Descriptions:
        ** input parameters: count
        ** output parameters: ?
        ** Returned value: ?
        *************************************************************************************/
        void Set_System(void)
        {
			RCC_Configuration(); //??

			GPIO_Configuration(); //??GPIO

			SPI_Configuration(); //??SPI1
        }


        void ENC28J60_CSL(void)
            {
        		DrvSPI_ClrSS(eDRVSPI_PORT1, eDRVSPI_SS0);
        		//Enable_SPI_CS;
            }

        void ENC28J60_CSH(void)
            {
        		DrvSPI_SetSS(eDRVSPI_PORT1,eDRVSPI_SS0);
        		//DISABLE_SPI_CS;
            }


		void ENC28J60_RESET(void)
			{
				DrvGPIO_ClrBit(E_GPC, 15);
				delay_ms(1000);
				DrvGPIO_SetBit(E_GPC, 15);
				delay_ms(1000);
			}
